/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 

package net.buildism;

import java.awt.DisplayMode;
import java.util.logging.Level;
import java.util.logging.Logger;
import net.buildism.object.Camera;
import net.buildism.object.GameObject;
import net.buildism.object.Part;
import net.buildism.type.Vec2D;
import net.buildism.ui.PartsTree;
import net.buildism.ui.PropsTable;


public class GameView_old {
    private Vec2D static_camPosition = null;
    private Vec2D camPosition = null;
    public double scaleFactor = 8;
    public Part followObject = null;
    public Vec2D offset = null;
    public double rotateOffset;
    private MainApplet mainFrame;
    private GamePanel mainPanel;
    public Vec2D followObjectPos = new Vec2D(0, 0);
    public boolean isFullscreen = false;
    private DisplayMode dispMode = Util.getGraphicsDevice().getDisplayMode();
    private PropsTable propsTable = new PropsTable();
    private PartsTree partsTree = new PartsTree();
    public boolean showUI = true;
    public GameView()
    {
        static_camPosition = new Vec2D(0, 0);
        camPosition = new Vec2D(0, 0);
        offset = new Vec2D(0, 0);
    }
    public void setup(MainApplet frame)
    {
        mainPanel = new GamePanel(this);
        mainPanel.setStartSize(frame.getWidth(), frame.getHeight());
        mainFrame = frame;
        mainFrame.setMainPanel(mainPanel);
        mainFrame.makeLayout();
        mainPanel.setup();
        mainFrame.setup();
    }
    public PropsTable getPropsTable()
    {
        return propsTable;
    }
    public PartsTree getPartsTree()
    {
        return partsTree;
    }
    public void setScaleFactor(double v) throws BuildismException
    {
        scaleFactor = v;
        if(Main.getGame() != null && Main.getGame().currentCamera != null)
            Main.getGame().currentCamera.setProp("ScaleFactor", v, false);
    }
    public void setCamPosition(Vec2D v, boolean fireEvent) throws BuildismException
    {
        camPosition = v;
        if(fireEvent && Main.getGame() != null && Main.getGame().currentCamera != null)
            Main.getGame().currentCamera.setProp("Position", v, false);
    }
    public void update()
    {
        if(followObject != null)
        {
            followObjectPos.set(followObject.getPosition());
            camPosition = new Vec2D(followObjectPos.x, followObjectPos.y + 10);
        }
       static_camPosition = camPosition.add(offset);
    }
    public Vec2D getCamPosition()
    {
        return static_camPosition;
    }
    public void translateCam(Vec2D tvec) throws BuildismException
    {
        camPosition = camPosition.add(tvec);
        if(Main.getGame() != null && Main.getGame().currentCamera != null)
            Main.getGame().currentCamera.setProp("Position", camPosition, false);
    }
    public int getWidth()
    {
        return mainPanel.getWidth();
    }
    public int getHeight()
    {
        return mainPanel.getHeight();
    }
    public MainApplet getMainFrame()
    {
        return mainFrame;
    }
    public GamePanel getGamePanel()
    {
        return mainPanel;
    }
    public void setViewPropertiesFromCamera(Camera camera)
    {
        try {
            scaleFactor = camera.getFloatProp("ScaleFactor");
            GameObject obj = camera.getObjectProp("FollowObject");
            if(obj instanceof Part)
                followObject = (Part) obj;
            camPosition = camera.getVec2DProp("Position");
            offset = camera.getVec2DProp("Offset");
            rotateOffset = camera.getFloatProp("RotationOffset");
        } catch (BuildismException ex) {
            Logger.getLogger(GameView.class.getName()).log(Level.SEVERE, null, ex);
        }

    }
    /*public void enterFullscreen()
    {
        if(isFullscreen)
            return;
        if(UI.toolsVisible)
            mainFrame.getGamePanel().getEditorTop().resizeWindowItem.setEnabled(false);
        mainFrame.dispose();
        mainFrame.setExtendedState(mainFrame.getExtendedState()|JFrame.MAXIMIZED_BOTH);
        mainFrame.setUndecorated(true);
        mainFrame.setVisible(true);
        isFullscreen = true;
    }
    public void exitFullscreen()
    {
        if(!isFullscreen)
            return;
        if(UI.toolsVisible)
        mainFrame.getGamePanel().getEditorTop().resizeWindowItem.setEnabled(true);
        mainFrame.dispose();
        mainFrame.setUndecorated(false);
        mainFrame.setVisible(true);
        mainFrame.setSize(1024, 768);
        mainFrame.setLocationRelativeTo(null);
        isFullscreen = false;
    }*-/
}
*/