/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.buildism.object;

import net.buildism.BuildismException;
import net.buildism.PhysicsController;
import net.buildism.PropChangeHandler;
import org.jbox2d.common.Vec2D;


public class FixedVelocity extends GameObject{
    private boolean running;
    private Part part;
    private Vec2D vec2;
    private int timer = 0;
    private PhysicsController controller;
    public FixedVelocity() throws BuildismException
    {
        super("FixedVelocity");
        addPropChangeHandler("Parent", new PropChangeHandler()
        {
            @Override
            public void handle(Object oldValue, Object value) throws BuildismException {
                onParentChanged((GameObject) oldValue, (GameObject) value);
                if(value instanceof Part)
                {
                    if(oldValue instanceof Part)
                        stop();
                    if(part != null)
                        start((Part)value);
                }
            }
        });
        addPropChangeHandler("Velocity", new PropChangeHandler()
        {
            @Override
            public void handle(Object oldValue, Object value) throws BuildismException {
                Vec2D v = (Vec2D) value;
                vec2 = v;
            }
        });
        //x_;
    }
    @Override
    public void addToWorld() throws BuildismException
    {
        super.addToWorld();
        if(getParent() instanceof Part)
            start((Part)getParent());
    }
    private void start(Part p)
    {
        part = p;
        part.getBody().wakeUp();
        if(!part.hasController(controller))
        {
            part.getBody().m_fixedVelocity = true;
            controller = new PhysicsController()
            {

                @Override
                public void run() {
                    part.getBody().wakeUp();
                    if(vec2 != null && part != null)
                    {
                        if(vec2.x != 0.0)
                            part.getBody().m_linearVelocity.x = vec2.x;
                        if(vec2.y != 0.0)
                            part.getBody().m_linearVelocity.y = vec2.y;
                    }
                }

            };
            part.addController(controller);
        }
    }
    private void stop()
    {
        if(part != null)
        {
            part.getBody().m_fixedVelocity = false;
            part.removeController(controller);
        }
    }
    @Override
    public void destructor() throws BuildismException
    {
        super.destructor();
        stop();
    }
}
