/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.buildism.object;

import net.buildism.BuildismException;
import net.buildism.PropChangeHandler;


public class Label extends GameObject
{
    private Part parent;
    private void rebuildLabel() throws BuildismException
    {
        Part p = ((Part)getParent());
        parent = p;
        p.setLabel(getStringProp("Text"));
    }
    public Label() throws BuildismException
    {
        super("Label");
        addPropChangeHandler("Text", new PropChangeHandler()
        {
            @Override
            public void handle(Object oldValue, Object value) throws BuildismException {
                String path = value.toString();
                    if(inWorld && getParent() instanceof Part)
                        rebuildLabel();
            }
        });
        addPropChangeHandler("Parent", new PropChangeHandler()
        {
            @Override
            public void handle(Object oldValue, Object value) throws BuildismException {
                onParentChanged((GameObject) oldValue, (GameObject) value);
                if(inWorld)
                {
                    if(value instanceof Part && value != null)
                        rebuildLabel();
                    else if(parent != null)
                        parent.setLabel(null);
                }
            }
        });
        //x_;
    }
    public void destructor() throws BuildismException
    {
        super.destructor();
        if(parent != null)
        {
            parent.setLabel(null);
        }
    }
    @Override
    public void addToWorld() throws BuildismException
    {
        super.addToWorld();
        if(getParent() instanceof Part)
        {
            rebuildLabel();
        }
    }
}
