/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.buildism.object;

import java.util.logging.Level;
import java.util.logging.Logger;
import net.buildism.BuildismException;
import net.buildism.Main;
import net.buildism.PropChangeHandler;
import net.buildism.Util;
import net.buildism.net.Client;
import net.buildism.ui.UI;
import se.krka.kahlua.vm.JavaFunction;
import se.krka.kahlua.vm.LuaCallFrame;


public class NetworkClient extends GameObject{
    private int port;
    private String ip;
    private Client client;
    public NetworkClient() throws BuildismException
    {
        super("NetworkClient");
        addPropChangeHandler("IP", new PropChangeHandler()
        {

            @Override
            public void handle(Object oldValue, Object value) throws BuildismException {
                ip = value.toString();
            }
        });
        addPropChangeHandler("Port", new PropChangeHandler()
        {

            @Override
            public void handle(Object oldValue, Object value) throws BuildismException {
                if(Util.isInteger(value.toString()))
                    port = Integer.parseInt(value.toString());
            }
        });
        addPropChangeHandler("LocalPlayer", new PropChangeHandler()
        {
            @Override
            public void handle(Object oldValue, Object value) throws BuildismException {
                Main.setLocalPlayer((Player) value);
            }

        });
        //x_;
        addFunction("start", new JavaFunction()
        {

            public int call(LuaCallFrame callFrame, int nArguments) {
                try {
                    String ip = (String) callFrame.get(1);
                    double port = (Double) callFrame.get(2);
                    setProp("IP", ip, true);
                    setProp("Port", (int) port, true);
                    start();
                } catch (BuildismException ex) {
                    Logger.getLogger(NetworkClient.class.getName()).log(Level.SEVERE, null, ex);
                }
                return 0;
            }

        });
    }
    @Override
    public void addToWorld() throws BuildismException
    {
        super.addToWorld();
    }
    public void start()
    {
        Main.runInMainThread(new Runnable()
        {

            public void run() {
                UI.mouseMode = UI.MODE_NONE;
                Main.setClientObject((NetworkClient) instance);
                Main.setLoading(true);
                Main.getGame().getCurrentWorld().setMessage("Connecting...");
                client = new Client((NetworkClient) instance, ip, port);
                Main.setClient(client);
            }
        });
    }
}
