/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.buildism.object;

import net.buildism.BuildismException;
import net.buildism.Main;
import net.buildism.PropChangeHandler;
import org.jbox2d.collision.shapes.PolygonDef;
import org.jbox2d.common.Vec2D;


public class Seat extends Box{
    public Seat() throws BuildismException
    {
        super("Seat");
        addPropChangeHandler("Size", new PropChangeHandler()
        {
            @Override
            public void handle(final Object oldValue, final Object value) throws BuildismException {

                try {
                    Vec2D vec = (Vec2D) value;
                    ((PolygonDef) sd).setAsBox((float) vec.x / 2, (float) vec.y / 2);
                    if(inWorld)
                        rebuildShape();
                    size = (Vec2D) value;
                } catch (BuildismException ex) {
                    throw new RuntimeException(ex);
                }
            }
        });
        addPropChangeHandler("Position", new PropChangeHandler()
        {
            @Override
            public void handle(final Object oldValue, final Object value) throws BuildismException {
                if(inWorld)
                {
                    Vec2D pos = (Vec2D) value;
                    body.setXForm(pos, body.getAngle());
                    body.wakeUp();
                    wakeUpConnected();
                }
                else
                    bd.position = ((Vec2D)value);
            }
        });
    }
    @Override
    public void destructor() throws BuildismException
    {
        super.destructor();
        if(Main.getLocalPlayer() != null && Main.getLocalPlayer().getCharacter() != null && Main.getLocalPlayer().getCharacter().seat == this)
            Main.getLocalPlayer().getCharacter().setSeat(null);
    }
}
