/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.buildism.object;

import java.util.ArrayList;
import net.buildism.BuildismException;
import org.jbox2d.common.Vec2D;
import se.krka.kahlua.vm.JavaFunction;
import se.krka.kahlua.vm.LuaCallFrame;


public class SpawnManager extends GameObject{
    private ArrayList<Part> spawnParts = new ArrayList<Part>(16);
    public SpawnManager() throws BuildismException
    {
        super("SpawnManager");
        explorable = false;
        addFunction("getSpawn", new JavaFunction()
        {

            public int call(LuaCallFrame callFrame, int nArguments) {
                callFrame.push(getSpawn());
                return 1;
            }

        });
        //x_;
    }
    public void addSpawn(Part p)
    {
        if(!spawnParts.contains(p))
            spawnParts.add(p);
    }
    public void removeSpawn(Part p)
    {
        if(spawnParts.contains(p))
            spawnParts.remove(p);
    }
    public Vec2D getSpawn()
    {
        if(spawnParts.size() == 0)
            return new Vec2D(world.getWidth()/2, world.getHeight()/2);
        else
        {
            int r = (int) Math.round(Math.random() * (spawnParts.size() - 1));
            return spawnParts.get(r).getPosition();
        }
    }
}
