/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.buildism.object;

import net.buildism.BuildismException;
import net.buildism.Main;
import net.buildism.PropChangeHandler;


public class SpawnPoint extends GameObject{
    private Part parent;
    public SpawnPoint() throws BuildismException
    {
        super("SpawnPoint");
        addPropChangeHandler("Parent", new PropChangeHandler()
        {
            @Override
            public void handle(Object oldValue, Object value) throws BuildismException {
                onParentChanged((GameObject) oldValue, (GameObject) value);
                if(inWorld)
                {
                    if(value instanceof Part && value != null)
                        rebuildSpawn();
                    else if(parent != null)
                        removeSpawn();
                }
            }
        });
        //x_;
    }
    private void rebuildSpawn() throws BuildismException
    {
        if(parent != null)
            removeSpawn();
        Part p = ((Part)getParent());
        parent = p;
        ((SpawnManager)world.getService("SpawnManager")).addSpawn(p);
    }
    private void removeSpawn() throws BuildismException
    {
        ((SpawnManager)world.getService("SpawnManager")).removeSpawn(parent);
    }
    public void destructor() throws BuildismException
    {
        super.destructor();
        if(parent != null)
        {
            removeSpawn();
        }
    }
    public void addToWorld() throws BuildismException
    {
        super.addToWorld();
        if(getParent() instanceof Part)
        {
            rebuildSpawn();
        }
    }
}
