/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.buildism.object;

import net.buildism.BuildismException;
import net.buildism.PhysicsController;
import net.buildism.PropChangeHandler;
import org.jbox2d.common.Vec2D;


public class VelocityController extends GameObject{
    private Part part;
    private Vec2D vec2;
    private int timer = 0;
    private PhysicsController controller;
    private boolean relative = false;
    public VelocityController() throws BuildismException
    {
        super("VelocityController");
        addPropChangeHandler("Parent", new PropChangeHandler()
        {
            @Override
            public void handle(Object oldValue, Object value) throws BuildismException {
                onParentChanged((GameObject) oldValue, (GameObject) value);
                if(value instanceof Part && value != oldValue)
                {
                    if(oldValue instanceof Part)
                        stop();
                    start((Part) value);
                }
            }
        });
        addPropChangeHandler("UseRelativeVector", new PropChangeHandler()
        {
            @Override
            public void handle(Object oldValue, Object value) throws BuildismException {
                relative = (Boolean) value;
            }
        });
        addPropChangeHandler("Velocity", new PropChangeHandler()
        {
            @Override
            public void handle(Object oldValue, Object value) throws BuildismException {
                vec2 = (Vec2D) value;
            }
        });
        //x_;
    }
    @Override
    public void addToWorld() throws BuildismException
    {
        super.addToWorld();
        if(getParent() instanceof Part)
            start((Part)getParent());
    }
    private void start(Part p)
    {
        part = p;
        controller = new PhysicsController()
        {
            @Override
            public void run() {
                if(!disabled && timer > 5)
                {
                    part.getBody().wakeUp();
                    if(vec2 != null && part != null)
                    {
                        if(!relative)
                        {
                            if(part.getBody().waterVelocity != null)
                                part.getBody().addLinearVelocity(vec2.add(part.getBody().waterVelocity));
                            else
                                part.getBody().addLinearVelocity(vec2);
                        }
                        else
                        {
                            Vec2D look = new Vec2D(vec2.toAngle() + part.getBody().getAngle() + part.rotationDiff).mul(vec2.length());
                            if(part.getBody().waterVelocity != null)
                                part.getBody().addLinearVelocity(look.add(part.getBody().waterVelocity));
                            else
                                part.getBody().addLinearVelocity(look);
                        }
                    }
                    timer = 0;
                }
                timer++;
            }

        };
        part.addController(controller);
    }
    private void stop()
    {
        vec2 = new Vec2D(0, 0);
        if(part != null)
            part.removeController(controller);
    }
    @Override
    public void destructor() throws BuildismException
    {
        super.destructor();
        stop();
    }
}
