/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.buildism.ui;

import java.awt.Color;
import java.awt.Component;
import javax.swing.BorderFactory;
import javax.swing.JCheckBox;
import javax.swing.JTextField;
import net.buildism.component.JColorPicker;
import net.buildism.ObjectList;
import net.buildism.PropertyDef;
import net.buildism.Util;


public class PropsTableCellComponent {
    public static Component getComponentFor(PropsTableCellEditor e, String type, int column, String name, Object value)
    {
        Component c = null;
        if(UI.getSelected().isEmpty())
        {
            c = new JTextField();
            ((JTextField)c).setBorder(BorderFactory.createEmptyBorder(2, 2, 2, 2));
            if(!(value instanceof Float))
            {
                if(value != null)
                    ((JTextField)c).setText(value.toString());
                else
                    ((JTextField)c).setText("");
            }
            else
            {
                float d = (Float) value;
                if(value != null)
                    ((JTextField)c).setText(Double.toString(Util.roundTwoDecimals(d)));
                else
                    ((JTextField)c).setText("");
            }
            return c;
        }
        else
        {
            PropertyDef def;
            def = ObjectList.getPropDef(type, name);
            if(def == null)
                return new JTextField();
            if(column == 0)
            {
                c = new JTextField();
                if(!def.guiEditable)
                    c.setForeground(java.awt.Color.gray);
               ((JTextField)c).setBorder(BorderFactory.createEmptyBorder(2, 2, 2, 2));
               ((JTextField)c).setText(value.toString());
            }
            else
            {
                Class propType = def.type;
                if(propType == Boolean.class)
                {
                    if(value == null)
                        value = false;
                    c = new JCheckBox();
                    c.setBackground(java.awt.Color.white);
                    ((JCheckBox)c).setSelected((Boolean) value);
                }
                else if(propType == Color.class)
                {
                    if(value == null)
                        value = new Color(0, 0, 0);
                    c = new JColorPicker(e, (Color) value);
                }
                else
                {
                    if(value == null)
                        value = "";
                    c = new JTextField();
                    ((JTextField)c).setBorder(BorderFactory.createEmptyBorder(2, 2, 2, 2));
                    if(!(value instanceof Float))
                        ((JTextField)c).setText(value.toString());
                    else
                    {
                        float d = Float.parseFloat(value.toString());
                        ((JTextField)c).setText(Double.toString(Util.roundTwoDecimals(d)));
                    }
                }
            }
        }
        return c;
    }
}
