/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.buildism.launcher;

import java.io.FilterInputStream;
import java.io.IOException;
import java.io.InputStream;
import javax.swing.JProgressBar;


public class ProgressBarInputStream extends FilterInputStream {

    private JProgressBar monitor;
    private int             nread = 0;
    private int             size = 0;

    public ProgressBarInputStream(InputStream in, JProgressBar monitor, int len) {
        super(in);
        this.in = in;
        size = len;
        this.monitor = monitor;
        monitor.setMaximum(size);
    }

    public JProgressBar getProgressBar() {
        return monitor;
    }

    @Override
    public int read() throws IOException {
        int c = in.read();
        if (c >= 0) monitor.setValue(++nread);
        return c;
    }

    @Override
    public int read(byte b[]) throws IOException {
        int nr = in.read(b);
        if (nr > 0) monitor.setValue(nread += nr);
        return nr;
    }

    @Override
    public int read(byte b[],
                    int off,
                    int len) throws IOException {
        int nr = in.read(b, off, len);
        if (nr > 0) monitor.setValue(nread += nr);
        return nr;
    }

    @Override
    public long skip(long n) throws IOException {
        long nr = in.skip(n);
        if (nr > 0) monitor.setValue(nread += nr);
        return nr;
    }

    @Override
    public void close() throws IOException {
        in.close();
    }

    @Override
    public synchronized void reset() throws IOException {
        in.reset();
        nread = size - in.available();
        monitor.setValue(nread);
    }

    public void setMaxValue(int iMax)
    {
        monitor.setMaximum(iMax);
        monitor.setValue(nread);
    }
}
